#include "listType.bi"

type mapValue
    nextL as mapValue ptr 
    prevL as mapValue ptr 
    key as listType
    value as listType
end type



type map
    f as mapValue ptr
    c as integer

    declare constructor ()
    
    declare sub add(byval k as listType, byval t as listType)
    declare sub remove(byval key as listType)
    declare sub remove(byval i2 as integer)
    declare sub removeAll(byval t as listType)
    declare sub insert(byval k as listType, byval t as listType)
    declare sub move(byval from as listType, byval t as listType)
    declare sub swapItems(byval from as listType, byval t as listType)
    
    declare function get(byval k as listType) as listType
    declare function value(byval k as listType) as listType
    declare function value(byval k as listType, byval default as listType) as listType
    
    declare function count overload () as integer
    declare function count(byval key as listType) as integer
    declare sub clear()
    
    
    declare function isEmpty() as integer
    
    declare function contains(byval k as listType) as integer
    
    declare sub replace (byval k as listType, byval t as listType)
end type


constructor map
    f = 0
    c = 0
end constructor


sub map.add(byval k as listType, byval t as listType)
    dim as mapValue ptr v
    v = f
    if v = 0 then
        f = new mapValue
        f->nextL = 0
        f->prevL = 0
        f->value = t
        f->key = k
        c = c + 1
        exit sub
    end if
    
    do
        if v->nextL = 0 then
            exit do
        end if
        v = v->nextL
    loop
    v->nextL = new mapValue
    v->nextL->nextL = 0
    v->nextL->prevL = v
    v->nextL->value = t
    v->nextL->key = k
    c = c + 1
end sub


sub map.insert(byval k as listType, byval t as listType)
    if contains(k) then 
        replace(k,t)
        exit sub
    end if
    add(k,t)
end sub


function map.value(byval k as listType) as listType
    return get(k)
end function


function map.value(byval k as listType, byval default as listType) as listType
    if contains(k) then return get(k)
    return default
end function


function map.get(byval k as listType) as listType
    dim as mapValue ptr v
    dim as integer i = 0
    v = f
    
    do
        if v->key = k then return v->value
        if v->nextL = 0 then return listType
        v = v->nextL
    loop
end function


sub map.replace (byval k as listType, byval t as listType)
    dim as mapValue ptr v
    dim as integer i = 0
    v = f
    
    if c = 0 then exit sub
    
    do
        i = i + 1
        if v->key = k then 
            v->value = t
            exit sub
        end if
        if v->nextL = 0 then exit sub
        v = v->nextL
    loop
    v->value = t
end sub


function map.contains(byval k as listType) as integer
    dim as mapValue ptr v
    v = f
    if c = 0 then
        return 0
    end if
    
    do
        if v->key = k then return -1
        if v->nextL = 0 then
            exit do
        end if
        v = v->nextL
    loop
    return 0
end function


function map.count() as integer
    return c
end function


function map.count(byval k as listType) as integer
    dim as mapValue ptr v
    dim as integer i = 0
    v = f
    if c = 0 then
        return 0
    end if
    
    do
        if v->key = k then i = i + 1
        if v->nextL = 0 then
            exit do
        end if
        v = v->nextL
    loop
    return i 
end function


sub map.clear()
    do
        remove(cast(integer,1))
    loop until c = 0
end sub


function map.isEmpty() as integer
    if c = 0 then return -1
    return 0
end function


sub map.remove(byval k as listType)
    dim as mapValue ptr v
    dim as integer i = 0
    v = f
    
    
    do
        i = i + 1
        if v->key = k then exit do
        if v->nextL = 0 then exit sub
        v = v->nextL
    loop
    if v->nextL <> 0 and v->prevL <> 0 then
        v->nextL->prevL = v->prevL
        v->prevL->nextL = v->nextL
        delete v
        c = c - 1
    elseif v->prevL = 0 and v->nextL <> 0 then
        f = v->nextL
        f->prevL = 0
        delete v
        c = c - 1
    elseif v->nextL = 0 and v->prevL <> 0 then
        v->prevL->nextL = 0
        delete v
        c = c - 1
    else
        f = 0
        delete v
        c = 0
    end if
end sub


sub map.remove(byval i2 as integer)
    dim as mapValue ptr v
    dim as integer i = 0
    v = f
    if i2 < 1 or i2 > c then
        exit sub
    end if
    
    do
        i = i + 1
        if i = i2 then exit do
        v = v->nextL
    loop
    if v->nextL <> 0 and v->prevL <> 0 then
        v->nextL->prevL = v->prevL
        v->prevL->nextL = v->nextL
        delete v
        c = c - 1
    elseif v->prevL = 0 and v->nextL <> 0 then
        f = v->nextL
        f->prevL = 0
        delete v
        c = c - 1
    elseif v->nextL = 0 and v->prevL <> 0 then
        v->prevL->nextL = 0
        delete v
        c = c - 1
    else
        f = 0
        delete v
        c = 0
    end if
end sub


sub map.removeAll(byval k as listType)
    do
        if contains(k) then
            remove(k)
        else
            exit sub
        end if
    loop
end sub


sub map.move(byval from as listType, byval t as listType)
    if contains(from) then exit sub
    if contains(t) then
        replace(t,get(from))
        remove(from)
        exit sub
    end if
    add(t,get(from))
    remove(from)
end sub


sub map.swapItems(byval from as listType, byval t as listType)
    dim as listType typ
    typ = get(from)
    replace(from,get(t))
    replace(t,typ)
end sub
